/**
 * Hello World Server
 *
 */

import java.io.IOException;
import java.net.Socket;
import java.net.ServerSocket;
import javax.net.ServerSocketFactory;
import javax.net.ssl.SSLServerSocketFactory;
import javax.net.ssl.SSLServerSocket;

public class HelloWorldSSLServ {

    static int port = 40000;

    public static void main(String[] args) {

	SSLServerSocketFactory ssf = 
           (SSLServerSocketFactory) SSLServerSocketFactory.getDefault();
	String[] dcs = ssf.getDefaultCipherSuites();
	//String[] dcs = ssf.getSupportedCipherSuites();
	System.out.print("\nciphers = ");
	for (int i = 0; i < dcs.length; i++ ) {
            System.out.print(dcs[i]);
	    if ( i < dcs.length-1 ) {
               System.out.print(", ");
	    }
	}
        System.out.println(".\n");

	try {
            ServerSocket so = ssf.createServerSocket( port );
	    System.out.println("Server startet on port "+port);

	    while (true) {

         	    System.out.println("waiting for connection ... ");
                    Socket s = so.accept();
         	    System.out.println("new connection from " 
                                      +  s.getInetAddress() );
		    
                    SocketChannel c = new SocketChannel(s);
         	    System.out.println("Object Stream created "); 
		    
                    Object o = c.receive();
         	    System.out.println("message 1 " + o); 

                    o = c.receive();
         	    System.out.println("message 2 " + o); 

                    c.close();

	    }


	} catch (IOException e) {
	    System.out.println("IOException "+e);
	}
	catch (ClassNotFoundException e) {
	    System.out.println("ClassNotFoundException "+e);
	}

    }


}
